include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext MonoPattern
ext VramSwitch

pSource equ ZW0
pVram equ ZW0
count equ ZB0
VramH equ ZB1


cseg
CopyToVdp:
    do
        ldy #0
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            jsr WaitVdp
            cpy #8
        while ne | wend
        lda <pSource | clc|adc #8 | sta <pSource
        lda <pSource+1 | adc #0 | sta <pSource+1
        dex
    while ne | wend
rts
; VdpValues:
;     defb $02, $e2
;     defb Vram_PatternName shr 10
;     defb (Vram_Color shr 6) or $7f
;     defb (Vram_PatternGenerator shr 11) or $03
;     defb Vram_SpriteAttribute shr 7
;     defb Vram_SpriteGenerator shr 11
;     defb $00
ColorSource:
defb 8, $f0 ; Ascii
defb 2, $a0 ; Logo
defb 1, $f0 ; Remain
defb 1, $b0 ; Floor
defb 1, $e0 ; Needle
defb 1, $50 ; Item
defb 0
cseg
InitVram: public InitVram
    sei
        ; ldy #$80
        ; ldx #0
        ; do
        ;     lda VdpValues,x | inx
        ;     sta VdpWritePort+1
        ;     tya | sta VdpWritePort+1
        ;     iny
        ;     cpx #8
        ; while ne | wend
            
        lda #0 | sta <VramH
        do
            lda #low Vram_PatternGenerator | sta VdpWritePort+1
            lda #$40 or high Vram_PatternGenerator | ora <VramH | sta VdpWritePort+1

            lda #low MonoPattern | sta <pSource
            lda #high MonoPattern | sta <pSource+1
            ldx #Char_End
            jsr CopyToVdp

            lda #low Vram_Color | sta VdpWritePort+1
            lda #$40 or high Vram_Color | ora <VramH | sta VdpWritePort+1
            ldx #0
            do
                lda ColorSource,x
            while ne
                sta <count
                inx
                lda ColorSource,x | inx
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dec <count
                while ne | wend
            wend
            
            lda <VramH | clc|adc #8 | sta <VramH
            cmp #8*3
        while ne | wend
    cli
    WaitVdp: public WaitVdp
rts


; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    pha
        sei
            lda #low Vram_PatternName | sta VdpWritePort+1
            lda #$40 or high Vram_PatternName | sta VdpWritePort+1
            lda #Char_Space
            ldy #8
            do
                ldx #0
                do
                    sta VdpWritePort
                    jsr WaitVdp
                    dex
                while ne | wend
                dey
            while ne | wend
        cli
        lda #0 | sta VramSwitch
        lda #$06 | sta VdpWritePort+1
        lda #$82 | sta VdpWritePort+1
        lda #$00 | sta VdpWritePort+1
        lda #$84 | sta VdpWritePort+1
    pla
rts


; ptr<byte> VramAddress(byte x, byte y)
dseg
VramAddress_@Param0: public	VramAddress_@Param0
VramAddress_.x_:
    defs 1
VramAddress_@Param1: public	VramAddress_@Param1
VramAddress_.y_:
    defs 1
cseg
VramAddress_: public VramAddress_
    pha
        lda #0 | sta <pVram+1
        lda	VramAddress_.y_
        asl	a ; *2
        asl	a ; *4
        asl	a | rol <pVram+1 ; *8
        asl	a | rol <pVram+1 ; *16
        asl	a | rol <pVram+1 ; *32

        clc|adc VramAddress_.x_ | tay
        lda <pVram+1 | adc #0 | tax

        tya clc|adc #low Vram | tay
        txa adc #high Vram | tax
	pla
rts


; ptr<byte> Put(ptr<byte> wVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
Put_@Param0: public Put_@Param0
Put_wVram:
    defw 0
PrintC_@Param1: public PrintC_@Param1
Put_@Param1: public Put_@Param1
Put_c:
PrintC_c:
    defb 0
cseg
Put:
    sei
        tax
        lda Put_wVram | sta VdpWritePort+1
        lda Put_wVram+1 | ora #$40 | sta VdpWritePort+1
        txa | sta VdpWritePort
    cli
    jsr WaitVdp
    sei
        lda Put_wVram | sta VdpWritePort+1
        lda Put_wVram+1 | ora #$40 | clc|adc #$04 | sta VdpWritePort+1
        txa | sta VdpWritePort
    cli
    jsr WaitVdp

    lda Put_wVram | clc|adc #1 | tay
    lda Put_wVram+1 | adc #0 | tax
rts
Put_: public Put_
    pha
        lda Put_c
        jsr Put
    pla
rts


; ptr<byte> PrintC(ptr<byte> wVram, byte c);
cseg
PrintC_: public PrintC_
    pha
        lda PrintC_c
        sec|sbc #$20
        jsr Put
    pla
rts