include "ZeroPage.inc"
include "Port.inc"
include "Vram.inc"
include "Chars.inc"

ext CellMap_,LeftX_,DotOffset_
ext WaitVdp

ColumnCount equ 16*8
FloorCount equ 5
FloorHeight equ 4
ColumnsPerByte equ 4
MapWidth equ ColumnCount/ColumnsPerByte

dseg
VramSwitch: public VramSwitch
    defb 0
FloorBuff: public FloorBuff
    defs VramWidth*FloorHeight

pSource equ ZW0
wVram equ ZW1
cellOffset equ ZW2
xLeft equ ZW2+1
leftByte equ ZW3
rightByte equ ZW3+1
fCount equ ZB0
xPos equ ZB1
xMod equ ZB2
cCount equ ZB3
yCount equ ZB4
xCount equ ZB5

VramTop1 equ $4000 or (Vram_PatternName+VramRowSize*(VramHeight-FloorHeight*FloorCount))
VramTop2 equ $4000 or (Vram_PatternName2+VramRowSize*(VramHeight-FloorHeight*FloorCount))


; void MapToVram();
cseg
MapToVram_: public MapToVram_
    pha
        lda VramSwitch
        eor #$01
        sta VramSwitch
        jsr UpdateChars_

        lda VramSwitch
        if eq
            ldy #low VramTop1 | ldx #high VramTop1
        else
            ldy #low VramTop2 | ldx #high VramTop2
        endif
        sty <wVram | stx <wVram+1

        ldy #0
        lda LeftX_
        and #1
        if ne
           dey
        endif
        sty <xLeft

        lda LeftX_
        lsr a | lsr a | lsr a
        sta <cellOffset

        lda #FloorCount | sta <fCount
        do
            lda <xLeft | sta <xPos | tay
            lda LeftX_ | lsr a | and #3 | sta <xMod

                                        _deb: public _deb
            ldx <cellOffset
            lda CellMap_,x | inx | sta <leftByte
            lda CellMap_,x | inx
            stx <cellOffset
            ldx <xMod
            do | while ne
                lsr a | ror <leftByte
                lsr a | ror <leftByte
                dex
            wend
            sta <rightByte

            lda #VramWidth/2+1 | sta <cCount
            do
                lda <leftByte | and #$0f
                asl a | asl a | asl a ;*8
                tax

                lda #4 | sta <yCount
                do
                    lda #2 | sta <xCount
                    do
                        lda <xPos
                        cmp #VramWidth
                        if cc
                            lda CellChars,x
                            sta FloorBuff,y
                        endif
                        iny
                        inx
                        inc <xPos
                        dec <xCount
                    while ne | wend
                    tya | clc|adc #VramWidth-2 | tay
                    dec <xPos | dec <xPos
                    dec <yCount
                while ne | wend
                tya | clc|adc #-VramWidth*FloorHeight+2 | tay
                inc <xPos | inc <xPos

                lda <rightByte
                lsr a | ror <leftByte
                lsr a | ror <leftByte
                sta <rightByte

                lda <xMod
                clc|adc #1 | and #3
                sta <xMod
                if eq
                    ldx <cellOffset
                    lda CellMap_,x | inx
                    sta <rightByte
                    stx <cellOffset
                endif
                dec <cCount
            while ne | wend
            lda <xMod
            if eq
                ldx <cellOffset
                dex
                stx <cellOffset
            endif
            lda <cellOffset | clc|adc #MapWidth-(VramWidth/2+1)/ColumnsPerByte-2 | sta <cellOffset

            sei
                lda <wVram | sta VdpWritePort+1
                lda <wVram+1 | sta VdpWritePort+1
                ldx #0
                do
                    lda FloorBuff,x | inx
                    sta VdpWritePort
                    jsr WaitVdp
                    cpx #VramWidth*FloorHeight
                while ne | wend
            cli
            lda <wVram | clc|adc #VramWidth*FloorHeight | sta <wVram
            lda <wVram+1 | adc #0 | sta <wVram+1
            
            dec <fCount
        while ne | wend

        lda VramSwitch
        if eq
            ldy #$06 | ldx #$00
        else
            ldy #$07 | ldx #$01
        endif
        sty VdpWritePort+1
        lda #$82 | sta VdpWritePort+1
        stx VdpWritePort+1
        lda #$84 | sta VdpWritePort+1
    pla
rts


; void UpdateChars();
PatternGenerator1 equ $4000 or (Vram_PatternGenerator+CharHeight*Char_Floor)
PatternGenerator2 equ $4000 or (Vram_PatternGenerator2+CharHeight*Char_Floor)
cseg
UpdateChars_: public UpdateChars_
    pha
        lda #0 | sta <pSource+1
        lda DotOffset_
        and #7
        sta <pSource
        asl a ;*2
        asl a ;*4
        asl a ;*8
        asl a ;*16
        sec|sbc <pSource ;*15
        asl a | rol <pSource+1 ;*2
        asl a | rol <pSource+1 ;*4
        asl a | rol <pSource+1 ;*8
        clc|adc #low ShiftedPattern0 | sta <pSource
        lda <pSource+1 | adc #high ShiftedPattern0 | sta <pSource+1

        lda VramSwitch
        if eq
            ldy #low PatternGenerator1 | ldx #high PatternGenerator1
        else
            ldy #low PatternGenerator2 | ldx #high PatternGenerator2
        endif
        sty <wVram | stx <wVram+1

        ldy #0
        ldx #CharHeight*(Char_Floor_Gap-Char_Floor)
        jsr WriteBytes
        ldx #CharHeight*(Char_Needle-Char_Floor)
        jsr SkipBytes

        ldx #CharHeight*(Char_Needle_Gap-Char_Needle)
        jsr WriteBytes
        ldx #CharHeight*(Char_Item-Char_Needle)
        jsr SkipBytes
        
        ldx #CharHeight*(Char_Item_Gap-Char_Item)
        jsr WriteBytes
        ldx #CharHeight*(Char_End-Char_Item)
        jsr SkipBytes
    pla
rts
WriteBytes:
    sei
        lda <wVram | sta VdpWritePort+1
        lda <wVram+1 | sta VdpWritePort+1
        do
            lda (<pSource),y | iny
            sta VdpWritePort
            dex
        while ne | wend
    cli
rts
SkipBytes:
    stx <cellOffset
    lda <wVram | clc|adc <cellOffset | sta <wVram
    lda <wVram+1 | adc #0 | sta <wVram+1
rts


cseg
CellChars:
	; 0
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	; 1
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Floor_Floor,Char_Floor_Space
	; 2
	defb Char_Space,Char_Space
	defb Char_Item_TopLeft_Item_TopRight,Char_Item_TopRight_Space
	defb Char_Item_BottomLeft_Item_BottomRight,Char_Space
	defb Char_Floor_Floor,Char_Floor_Space
	; 3
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Needle_Needle,Char_Needle_Space
	defb Char_Floor_Floor,Char_Floor_Space
	; 4
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Floor
	; 5
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Floor_Floor,Char_Floor_Floor
	; 6
	defb Char_Space,Char_Space
	defb Char_Item_TopLeft_Item_TopRight,Char_Item_TopRight_Space
	defb Char_Item_BottomLeft_Item_BottomRight,Char_Space
	defb Char_Floor_Floor,Char_Floor_Floor
	; 7
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Needle_Needle,Char_Needle_Space
	defb Char_Floor_Floor,Char_Floor_Floor
	; 8
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Item_TopLeft
	defb Char_Space,Char_Space_Item_BottomLeft
	defb Char_Space,Char_Space_Floor
	; 9
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Item_TopLeft
	defb Char_Space,Char_Space_Item_BottomLeft
	defb Char_Floor_Floor,Char_Floor_Floor
	; 10
	defb Char_Space,Char_Space
	defb Char_Item_TopLeft_Item_TopRight,Char_Item_TopRight_Item_TopLeft
	defb Char_Item_BottomLeft_Item_BottomRight,Char_Item_BottomRight_Item_BottomLeft
	defb Char_Floor_Floor,Char_Floor_Floor
	; 11
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Item_TopLeft
	defb Char_Needle_Needle,Char_Needle_Item_BottomLeft
	defb Char_Floor_Floor,Char_Floor_Floor
	; 12
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Needle
	defb Char_Space,Char_Space_Floor
	; 13
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space_Needle
	defb Char_Floor_Floor,Char_Floor_Floor
	; 14
	defb Char_Space,Char_Space
	defb Char_Item_TopLeft_Item_TopRight,Char_Item_TopRight_Space
	defb Char_Item_BottomLeft_Item_BottomRight,Char_Item_BottomRight_Needle
	defb Char_Floor_Floor,Char_Floor_Floor
	; 15
	defb Char_Space,Char_Space
	defb Char_Space,Char_Space
	defb Char_Needle_Needle,Char_Needle_Needle
	defb Char_Floor_Floor,Char_Floor_Floor
ShiftedPattern0:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $10,$10,$38,$38,$7c,$7c,$fe,$fe
	; Needle1:Char_Needle_Needle
	defb $10,$10,$38,$38,$7c,$7c,$fe,$fe
	; Needle2:Char_Needle_Space
	defb $10,$10,$38,$38,$7c,$7c,$fe,$fe
	; Needle3:Char_Space_Needle
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $04,$04,$04,$04,$04,$04,$0e,$1f
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item2:Char_Item_BottomRight_Needle
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$07,$07,$07,$07,$07,$07,$07
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$f8,$f8,$f8,$f8,$f8,$f8,$f8
	; Item5:Char_Item_TopRight_Space
	defb $00,$f8,$f8,$f8,$f8,$f8,$f8,$f8
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern1:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $fe,$fe,$fe,$fe,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $01,$01,$01,$01,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $20,$20,$70,$70,$f8,$f8,$fc,$fc
	; Needle1:Char_Needle_Needle
	defb $20,$20,$70,$70,$f8,$f8,$fd,$fd
	; Needle2:Char_Needle_Space
	defb $20,$20,$70,$70,$f8,$f8,$fc,$fc
	; Needle3:Char_Space_Needle
	defb $00,$00,$00,$00,$00,$00,$01,$01
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $08,$08,$08,$08,$08,$08,$1c,$3e
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item2:Char_Item_BottomRight_Needle
	defb $00,$00,$00,$00,$00,$00,$01,$01
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$0f,$0f,$0f,$0f,$0f,$0f,$0f
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$f0,$f0,$f0,$f0,$f0,$f0,$f0
	; Item5:Char_Item_TopRight_Space
	defb $00,$f0,$f0,$f0,$f0,$f0,$f0,$f0
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern2:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $fc,$fc,$fc,$fc,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $03,$03,$03,$03,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $40,$40,$e0,$e0,$f0,$f0,$f8,$f8
	; Needle1:Char_Needle_Needle
	defb $40,$40,$e0,$e0,$f1,$f1,$fb,$fb
	; Needle2:Char_Needle_Space
	defb $40,$40,$e0,$e0,$f0,$f0,$f8,$f8
	; Needle3:Char_Space_Needle
	defb $00,$00,$00,$00,$01,$01,$03,$03
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $10,$10,$10,$10,$10,$10,$38,$7c
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item2:Char_Item_BottomRight_Needle
	defb $00,$00,$00,$00,$01,$01,$03,$03
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$1f,$1f,$1f,$1f,$1f,$1f,$1f
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	; Item5:Char_Item_TopRight_Space
	defb $00,$e0,$e0,$e0,$e0,$e0,$e0,$e0
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern3:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $f8,$f8,$f8,$f8,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $07,$07,$07,$07,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $80,$80,$c0,$c0,$e0,$e0,$f0,$f0
	; Needle1:Char_Needle_Needle
	defb $80,$80,$c1,$c1,$e3,$e3,$f7,$f7
	; Needle2:Char_Needle_Space
	defb $80,$80,$c0,$c0,$e0,$e0,$f0,$f0
	; Needle3:Char_Space_Needle
	defb $00,$00,$01,$01,$03,$03,$07,$07
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $20,$20,$20,$20,$20,$20,$70,$f8
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item2:Char_Item_BottomRight_Needle
	defb $00,$00,$01,$01,$03,$03,$07,$07
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$3f,$3f,$3f,$3f,$3f,$3f,$3f
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	; Item5:Char_Item_TopRight_Space
	defb $00,$c0,$c0,$c0,$c0,$c0,$c0,$c0
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern4:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $f0,$f0,$f0,$f0,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $0f,$0f,$0f,$0f,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $00,$00,$80,$80,$c0,$c0,$e0,$e1
	; Needle1:Char_Needle_Needle
	defb $01,$01,$83,$83,$c7,$c7,$ef,$ef
	; Needle2:Char_Needle_Space
	defb $00,$00,$80,$80,$c0,$c0,$e0,$e0
	; Needle3:Char_Space_Needle
	defb $01,$01,$03,$03,$07,$07,$0f,$0f
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $40,$40,$40,$40,$40,$40,$e0,$f0
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$01
	; Item2:Char_Item_BottomRight_Needle
	defb $01,$01,$03,$03,$07,$07,$0f,$0f
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$7f,$7f,$7f,$7f,$7f,$7f,$7f
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$80,$80,$80,$80,$80,$80,$80
	; Item5:Char_Item_TopRight_Space
	defb $00,$80,$80,$80,$80,$80,$80,$80
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$00,$01
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern5:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $e0,$e0,$e0,$e0,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $1f,$1f,$1f,$1f,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $00,$00,$00,$00,$80,$80,$c1,$c3
	; Needle1:Char_Needle_Needle
	defb $02,$02,$07,$07,$8f,$8f,$df,$df
	; Needle2:Char_Needle_Space
	defb $00,$00,$00,$00,$80,$80,$c0,$c0
	; Needle3:Char_Space_Needle
	defb $02,$02,$07,$07,$0f,$0f,$1f,$1f
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $80,$80,$80,$80,$80,$80,$c0,$e0
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$01,$03
	; Item2:Char_Item_BottomRight_Needle
	defb $02,$02,$07,$07,$0f,$0f,$1f,$1f
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$ff,$ff,$ff,$ff,$ff,$ff,$ff
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item5:Char_Item_TopRight_Space
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item6:Char_Space_Item_BottomLeft
	defb $00,$00,$00,$00,$00,$00,$01,$03
	; Item7:Char_Space_Item_TopLeft
	defb $00,$00,$00,$00,$00,$00,$00,$00
ShiftedPattern6:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $c0,$c0,$c0,$c0,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $3f,$3f,$3f,$3f,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $01,$01,$01,$01,$01,$01,$83,$87
	; Needle1:Char_Needle_Needle
	defb $04,$04,$0e,$0e,$1f,$1f,$bf,$bf
	; Needle2:Char_Needle_Space
	defb $00,$00,$00,$00,$00,$00,$80,$80
	; Needle3:Char_Space_Needle
	defb $04,$04,$0e,$0e,$1f,$1f,$3f,$3f
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $00,$00,$00,$00,$00,$00,$80,$c0
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $01,$01,$01,$01,$01,$01,$03,$07
	; Item2:Char_Item_BottomRight_Needle
	defb $04,$04,$0e,$0e,$1f,$1f,$3f,$3f
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$fe,$fe,$fe,$fe,$fe,$fe,$fe
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$01,$01,$01,$01,$01,$01,$01
	; Item5:Char_Item_TopRight_Space
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item6:Char_Space_Item_BottomLeft
	defb $01,$01,$01,$01,$01,$01,$03,$07
	; Item7:Char_Space_Item_TopLeft
	defb $00,$01,$01,$01,$01,$01,$01,$01
ShiftedPattern7:
	; Floor0:Char_Floor_Floor
	defb $ff,$ff,$ff,$ff,$00,$00,$00,$00
	; Floor1:Char_Floor_Space
	defb $80,$80,$80,$80,$00,$00,$00,$00
	; Floor2:Char_Space_Floor
	defb $7f,$7f,$7f,$7f,$00,$00,$00,$00
	; Needle0:Char_Needle_Item_BottomLeft
	defb $02,$02,$02,$02,$02,$02,$07,$0f
	; Needle1:Char_Needle_Needle
	defb $08,$08,$1c,$1c,$3e,$3e,$7f,$7f
	; Needle2:Char_Needle_Space
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Needle3:Char_Space_Needle
	defb $08,$08,$1c,$1c,$3e,$3e,$7f,$7f
	; Item0:Char_Item_BottomLeft_Item_BottomRight
	defb $00,$00,$00,$00,$00,$00,$00,$80
	; Item1:Char_Item_BottomRight_Item_BottomLeft
	defb $02,$02,$02,$02,$02,$02,$07,$0f
	; Item2:Char_Item_BottomRight_Needle
	defb $08,$08,$1c,$1c,$3e,$3e,$7f,$7f
	; Item3:Char_Item_TopLeft_Item_TopRight
	defb $00,$fc,$fc,$fc,$fc,$fc,$fc,$fc
	; Item4:Char_Item_TopRight_Item_TopLeft
	defb $00,$03,$03,$03,$03,$03,$03,$03
	; Item5:Char_Item_TopRight_Space
	defb $00,$00,$00,$00,$00,$00,$00,$00
	; Item6:Char_Space_Item_BottomLeft
	defb $02,$02,$02,$02,$02,$02,$07,$0f
	; Item7:Char_Space_Item_TopLeft
	defb $00,$03,$03,$03,$03,$03,$03,$03
